package com.denachina.pickle;

import android.Manifest;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.res.Configuration;
import android.graphics.Bitmap;
import android.graphics.drawable.BitmapDrawable;
import android.os.Build;
import android.os.Bundle;
import android.text.TextUtils;
import android.util.Log;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.ViewTreeObserver;
import android.view.Window;
import android.view.WindowManager;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.EditText;
import android.widget.FrameLayout;
import android.widget.LinearLayout;
import android.widget.PopupWindow;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.android.volley.DefaultRetryPolicy;
import com.android.volley.Request;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.denachina.lcm.LCMApplication;
import com.denachina.lcm.http.VolleyManager;
import com.denachina.lcm.localnotification.LocalNotification;
import com.denachina.lcm.localnotification.LocalNotificationManager;
import com.denachina.lcm.net.http.LCMJsonObjectRequest;
import com.denachina.lcm.net.http.LCMStringRequest;
import com.denachina.lcm.sdk.LCMError;
import com.denachina.lcm.sdk.LCMInitializer;
import com.denachina.lcm.sdk.LCMSDK;
import com.denachina.lcm.sdk.LCMSDK.OnGetAllUserIdsComplete;
import com.denachina.lcm.sdk.LCMSDK.OnResetUserComplete;
import com.denachina.lcm.sdk.LCMSDK.OnSwitchUserComplete;
import com.denachina.lcm.sdk.activation.LCMActivation;
import com.denachina.lcm.sdk.announcement.LCMAnnouncement;
import com.denachina.lcm.sdk.bank.VCBundle;
import com.denachina.lcm.sdk.bank.VCBundle.VCBundleCallback;
import com.denachina.lcm.sdk.bank.Wallet;
import com.denachina.lcm.sdk.bank.Wallet.WalletCallback;
import com.denachina.lcm.sdk.social.SocialInfo;
import com.denachina.lcm.sdk.update.LCMUpdater;
import com.denachina.lcm.sdk.update.LCMUpdater.ProcessChangeListener;
import com.denachina.lcm.sdk.user.IdBean;
import com.denachina.lcm.sdk.user.User;
import com.denachina.lcm.sdk.user.User.GetLinkInfoCallback;
import com.denachina.lcm.sdk.user.User.LinkAccountCallback;
import com.denachina.lcm.sdk.user.User.LinkOrLoadAccountCallback;
import com.denachina.lcm.sdk.user.User.LoadAccountCallback;
import com.denachina.lcm.sdk.user.User.UnlinkAccountCallback;
import com.denachina.pickle.ui.ArrowView;
import com.denachina.pickle.ui.MenubarView;
import com.denachina.pickle.ui.ProductItemView;
import com.denachina.pickle.ui.ProgressDialog;
import com.denachina.pickle.ui.PurchaseDialog;
import com.denachina.pickle.util.Base64;
import com.denachina.pickle.util.Base64DecoderException;
import com.denachina.pickle.util.ResourceManager;
import com.denachina.pickle.util.Utils;

import org.json.JSONException;
import org.json.JSONObject;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class SampleActivity extends Activity {
    private final String TAG = "SampleActivity";
    // Whether use L-coin: 1-yes; 0-no
    private static final int L_COIN_SWITCHER = 1;
    private String myEnv;
    private String lastOnSessionUpdate, lastOnSessionError, lastOnRemoteMessage, free, paid;
    private TextView onSessionUpdateTextView, onSessionErrorTextView, onRemoteMessageTextView;
    private Button linkBtn, linkOrLoadBtn, unlinkBtn, purchaseBtn, exitBtn, resetUserBtn, switchUserBtn, logoutBtn, setExtraBtn, menubarBtn;
    private User mUser;
    private List<SocialInfo> mLinkInfo;
    private View sampleSplashView, sampleGameInfoView;
    private List<VCBundle> vcBundleList;
    private List<SampleLostVCBundle> lostVcBundleList;
    private int screenWidth, screenHeight;
    private LCMSDK.EventHandler lcmEventHandler;
    private LCMApplication lcmApplication;
    private List<IdBean> mIdBeanList;
    private Dialog sampleOnSessionErrorDialog;
    private PurchaseDialog samplePurchaseDialog;
    private ProgressDialog samplePbDialog;
    private boolean isFirstToLinkOrLoad = false;
    private ResourceManager R;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        R = ResourceManager.getInstance(this);
        setContentView(R.getLayoutForId("activity_sample"));
        LayoutInflater inflater = (LayoutInflater) getSystemService(LAYOUT_INFLATER_SERVICE);
        sampleSplashView = inflater.inflate(R.getLayoutForId("splash_view"), null);
        addContentView(sampleSplashView, new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT));

//        Point size = new Point();
//        getWindowManager().getDefaultDisplay().getSize(size);

        screenWidth = getWindowManager().getDefaultDisplay().getWidth();
        screenHeight = getWindowManager().getDefaultDisplay().getHeight();
        lcmApplication = (LCMApplication) this.getApplication();
        initView();
//        lostVcBundleList = getLostVcBundleList();

        lcmEventHandler = new LCMSDK.EventHandler() {
            /**
             * Triggered when auth/init complete(success or fail).
             * @param lcmInitialization
             */
            public void onInitComplete(LCMInitializer lcmInitialization) {
                //Game should handle if lcmInitialization.getLcmError() is null,and do something different.
                Log.d(TAG, "onInitComplete.");
                final LCMError error = lcmInitialization.getLcmError();
                if (error == null) {
                    //LCMSDK.init() success.
                    //And then call LCMInitialization.continueProcessing() to continue.
                    lcmInitialization.hideSplash();
                    lcmInitialization.continueProcessing();
                    //CP Game first start here.!!!!!
                } else {
                    dissmissOnSessionErrorDialog();
                    lastOnSessionError = "errorCode: " + error.getErrorCode() + "\nerrorMsg: " + error.getErrorMsg() + "\nerrorType: " + error.getErrorType();
                    Log.e(TAG, lastOnSessionError);
                    // Update information displayed on screen
                    runOnUiThread(new Runnable() {
                        @Override
                        public void run() {
                            onSessionErrorTextView.setText(lastOnSessionError);
                            lastOnSessionUpdate = "";
                            onSessionUpdateTextView.setText(lastOnSessionUpdate);
                        }
                    });
                    Utils.showLongToastOnUiThread(SampleActivity.this, lastOnSessionError);
                    // Show a dialog to ask user whether to re-init again to go on with login
                    runOnUiThread(new Runnable() {
                        @Override
                        public void run() {
                            String msg = "Network unavailable. Retry?";
                            if (error.getErrorType() == LCMError.ErrorType.AUTH_STORE_ACCOUNT_ERROR) {
                                msg = "Auth error. Retry?";
                            }
                            try {
                                sampleOnSessionErrorDialog = new AlertDialog.Builder(SampleActivity.this).setTitle("Info").setMessage(msg).setPositiveButton("Yes", new DialogInterface.OnClickListener() {
                                    @Override
                                    public void onClick(DialogInterface dialog, int which) {
                                        LCMSDK.init(SampleActivity.this, lcmEventHandler);
                                        dialog.dismiss();
                                    }
                                }).setNegativeButton("No", new DialogInterface.OnClickListener() {
                                    @Override
                                    public void onClick(DialogInterface dialog, int which) {
                                        dialog.dismiss();
                                        SampleActivity.this.finish();
                                    }
                                }).create();
                                sampleOnSessionErrorDialog.setCancelable(false);
                                sampleOnSessionErrorDialog.show();
                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                        }
                    });
                }

            }

            /**
             * Triggered when remote notification exists
             * @param message
             * @param extras
             */
            @Override
            public void onRemoteMessage(String message, String extras) {
                lastOnRemoteMessage = "message: " + message + "\nextras: " + extras;
                Log.d(TAG, lastOnRemoteMessage);
                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        Utils.showLongToast(SampleActivity.this, lastOnRemoteMessage);
                        onRemoteMessageTextView.setText(lastOnRemoteMessage);
                    }
                });
            }

            /**
             * Triggered when login error or update session error, </br>
             * developer should invoke LCMSDK.login() if want to re-login again
             * @param error
             */
            @Override
            public void onSessionError(final LCMError error) {
                dissmissOnSessionErrorDialog();
                lastOnSessionError = "errorCode: " + error.getErrorCode() + "\nerrorMsg: " + error.getErrorMsg() + "\nerrorType: " + error.getErrorType();
                Log.e(TAG, lastOnSessionError);
                // Session ocucupied, kick off the current user
                if (error.getErrorType() == LCMError.ErrorType.AUTH_SESSION_OCCUPIED) {
                    new AlertDialog.Builder(SampleActivity.this).setTitle("Error").setMessage("Another device has logged on.\nClick OK to exit.").setPositiveButton("OK", new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            SampleActivity.this.finish();
                        }
                    }).create().show();
                    return;
                }
                // Freeze
                if (error.getErrorType() == LCMError.ErrorType.AUTH_USER_FREEZE_TEMPORARY
                        || error.getErrorType() == LCMError.ErrorType.AUTH_USER_FREEZE_PERMANENT) {
                    String msg;
                    switch (error.getErrorType()) {
                        case AUTH_USER_FREEZE_TEMPORARY:
                            msg = R.getString("freezing_temporary");
                            break;
                        case AUTH_USER_FREEZE_PERMANENT:
                            msg = R.getString("freezing_permanent");
                            break;
                        default:
                            msg = R.getString("freezing_temporary");
                            break;
                    }
                    AlertDialog.Builder builder = new AlertDialog.Builder(SampleActivity.this);
                    builder.setTitle(R.getString("freezing_message"));
                    builder.setMessage(R.getString("freezing_txt") + msg);
                    builder.setIcon(R.getDrawableForId("ic_launcher"));
                    builder.setPositiveButton(R.getString("freezing_close"), new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            SampleActivity.this.finish();
                        }
                    }).create().show();
                    return;
                }
                if (error.getErrorType() == LCMError.ErrorType.AUTH_CREDENTIAL_NO_GOOGLE_ACCOUNT) {
                    AlertDialog.Builder builder = new AlertDialog.Builder(SampleActivity.this);
                    builder.setTitle("no google account");
                    builder.setMessage("no google account, please login google account");
                    builder.setPositiveButton("OK", new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            dialog.dismiss();
                            SampleActivity.this.finish();
                        }
                    });
                    builder.show();
                    return;
                }
                // Update information displayed on screen
                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        onSessionErrorTextView.setText(lastOnSessionError);
                        lastOnSessionUpdate = "";
                        onSessionUpdateTextView.setText(lastOnSessionUpdate);
                    }
                });
                Utils.showLongToastOnUiThread(SampleActivity.this, lastOnSessionError);
                // Show a dialog to ask user whether to re-login
                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        String msg = "Network unavailable. Retry?";
                        if (error.getErrorType() == LCMError.ErrorType.AUTH_STORE_CREDENTIAL_ERROR) {
                            msg = "Auth error. Retry?";
                        }
                        try {
                            sampleOnSessionErrorDialog = new AlertDialog.Builder(SampleActivity.this).setTitle("Info").setMessage(msg).setPositiveButton("Yes", new DialogInterface.OnClickListener() {
                                @Override
                                public void onClick(DialogInterface dialog, int which) {
                                    LCMSDK.login();
                                    dialog.dismiss();
                                }
                            }).setNegativeButton("No", new DialogInterface.OnClickListener() {
                                @Override
                                public void onClick(DialogInterface dialog, int which) {
                                    dialog.dismiss();
                                    SampleActivity.this.finish();
                                }
                            }).create();
                            sampleOnSessionErrorDialog.setCancelable(false);
                            sampleOnSessionErrorDialog.show();
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                    }
                });
            }

            /**
             * Triggered when update session success
             * @param accessToken
             * @param user
             */
            @Override
            public void onSessionUpdate(String accessToken, User user) {
                dissmissOnSessionErrorDialog();
                String decodedAccessToken = "";
                if (accessToken != null && accessToken.length() > 0) {
                    String[] atArray = accessToken.split("\\.");
                    if (atArray != null && atArray.length == 3) {
                        try {
                            String p1 = new String(Base64.decode(atArray[0].getBytes()));
                            String p2 = new String(Base64.decode(atArray[1].getBytes()));
                            decodedAccessToken = "\n\ndecodedAccessToken:\n" + p1 + "\n" + p2;
                        } catch (Base64DecoderException e) {
                            e.printStackTrace();
                        }
                    }
                }
                lastOnSessionUpdate = "accessToken: " + accessToken + "\n\nuser:\n" + user.toString() + decodedAccessToken;
                Log.d(TAG, lastOnSessionUpdate);
                SampleActivity.this.mUser = user;

                // Update IdBean of the current user
                sampleUpdateIdBean();
                // Fetch game info
                sampleFetchGameInfo();

                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        lastOnSessionError = "";
                        onSessionErrorTextView.setText(lastOnSessionError);
                        onSessionUpdateTextView.setText(lastOnSessionUpdate);
                    }
                });
            }

            /**
             * Triggered when force update exists
             * @param updater
             */
            @Override
            public void onUpdate(LCMUpdater updater) {
                Log.d(TAG, "onUpdate. updater:" + updater.toString());
                dissmissOnSessionErrorDialog();
                //set the download path if necessary.You can skip this with a default path.
//		        updater.setTargetFilePath("/sdcard/dwonload/xxx.apk");

                // Open default UI
                updater.showDefaultUI();
                // Use this method to make a customized force update UI
//              showUpdateDialog(updater);

            }

            /**
             * Triggered when announcement exists, </br>
             * NOTICE: Result of LCMSDK.checkAnnouncement() will also be returned through this method
             * @param announcement
             */
            @Override
            public void onAnnouncement(final LCMAnnouncement announcement) {
                Log.d(TAG, "onAnnouncement. announcement:" + announcement);
                // Before login announcement
                if (announcement.isBeforeLoginAnnouncement()) {
                    //show announcement
                    /*If developer has customized Announcement UI, notice that you should
                     * call LCMSDK.shouldBlockResume(false) after user skip the announcement.
                     * And then call LCMAnnouncement.continueProcessing() to continue.
                     */
                    // Open a default dialog for user.
                    announcement.showDefaultUI(new LCMAnnouncement.AnnouncementCallback() {
                        @Override
                        public void onDismiss() {
                            //Nothing to do.
                        }
                    });
                }
                // After login announcement
                else {
                    // No announcement
                    if (announcement.getLCMError() != null) {
                        if (announcement.getLCMError().getErrorType() == LCMError.ErrorType.ANNOUNCEMENT_NONE_ERROR) {
                            Log.d(TAG, "No announcement");
                            // Start to logging in to game
                            sampleStartToLoggingInToGame();
                        }
                        // Check announcement error
                        else if (announcement.getLCMError().getErrorType() == LCMError.ErrorType.ANNOUNCEMENT_ERROR) {
                            Log.d(TAG, "Check announcement error");
                            // Start to logging in to game
                            sampleStartToLoggingInToGame();
                        }
                    }
                    // Has announcement
                    else {
                        //show announcement
                        // Open a default dialog for user.
                        announcement.showDefaultUI(new LCMAnnouncement.AnnouncementCallback() {
                            @Override
                            public void onDismiss() {
                                // Start to logging in to game
                                sampleStartToLoggingInToGame();
                            }
                        });
                    }
                }
            }

            /**
             * Triggered when activation needed
             * @param activation
             */
            @Override
            public void onActivation(final LCMActivation activation) {
                // Activation code is needed
                Log.d(TAG, "onActivation. activation:" + activation);
                dissmissOnSessionErrorDialog();
                //show Activation Dialog
                /*If developer has customized Activation UI, notice that you should
                 * call LCMSDK.setAuthCode() to pass activate code to LCMSDK,
	             * and then call LCMActivation.continueProcessing() to continue.
	             */
                // if CP do not want to achieve your own UI,Open a default dialog for user.
                activation.showDefaultUI();
                /** if CP want to achieve your own UI about Activation,CP should do like below.
                 *  Firstly,you show decode the layout json to a json object and get content in it,
                 *  and show your own UI with these infomation.
                 *  Secondly,you should use the infomation you got in layoutjson and then do something like below.
                 */

                /** decode json string and get infomation. **/
                /*String layoutJsonStr = activation.getLayoutJson();
                if(layoutJson != null){
                    try {
                        JSONObject json = new JSONObject(layoutJson);
                        final String title = json.optString("title");
                        final String content = json.optString("content");

                        //show your own dialog with title and content here.
                    } catch (JSONException e) {
                        Log.e(TAG, "showDefaultUI error, layoutJson has wrong format, please check", e);
                        Log.e(TAG, "Start to show a content specified default UI");

                        //show your own dialog with title and content error here.
                    }
                }else{
                    Log.e(TAG,"Activation layoutJson is null");
                    Log.e(TAG, "Start to show a content specified default UI");

                    //show your own dialog with title and content error here.
                }*/

                /** archieve the button click listeners like below with your own dialog UI. **/
                /*DialogInterface.OnClickListener positiveButtonOnClickListener = new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {

                        // Set active code inputed by user
                        String activateCode = "1234";
                        //put activation code into lcmsdk.
                        LCMSDK.setAuthCode(activateCode);
                        //continue
                        activation.continueProcessing();
                    }
                };
                DialogInterface.OnClickListener negativeButtonOnClickListener = new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        // NOTICE: mActivity may not be the main activity of game, so can not use Activity.finish() to close game
                        // Kill process
                        System.exit(0);
                    }
                };*/
            }

            /**
             * Triggered when logout completes
             * @param extra
             */
            @Override
            public void onLogoutComplete(String extra) {
                Log.i(TAG, "onLogoutComplete:" + extra);
                // Do your own logic
                mIdBeanList = null;
                // Re-login
                LCMSDK.login();
            }

            /**
             * Triggered when login completes </br>
             * NOTICE: It is recommended to getLinkInfo and VCBundles when user log in to game.
             * @param accessToken
             * @param user
             */
            @Override
            public void onLoginComplete(String accessToken, User user) {
                dissmissOnSessionErrorDialog();
                String decodedAccessToken = "";
                if (accessToken != null && accessToken.length() > 0) {
                    String[] atArray = accessToken.split("\\.");
                    if (atArray != null && atArray.length == 3) {
                        try {
                            String p1 = new String(Base64.decode(atArray[0].getBytes()));
                            String p2 = new String(Base64.decode(atArray[1].getBytes()));
                            decodedAccessToken = "\n\ndecodedAccessToken:\n" + p1 + "\n" + p2;
                        } catch (Base64DecoderException e) {
                            e.printStackTrace();
                        }
                    }
                }
                lastOnSessionUpdate = "accessToken: " + accessToken + "\n\nuser:\n" + user.toString() + decodedAccessToken;
                Log.d(TAG, lastOnSessionUpdate);
                SampleActivity.this.mUser = user;

                // Get link info
                mUser.getLinkInfo(SampleActivity.this, new GetLinkInfoCallback() {

                    @Override
                    public void onComplete(final List<SocialInfo> linkInfo, final LCMError error) {

                        if (error != null) {
                            String errorMsg = "getLinkInfo failed.\nerrorCode:" + error.getErrorCode() + "\nerrorMsg:" + error.getErrorMsg();
                            Log.e(TAG, errorMsg);
                            Utils.showLongToastOnUiThread(SampleActivity.this, errorMsg);
                        } else {
                            Log.d(TAG, "getLinkInfo success");
                            mLinkInfo = linkInfo;
                        }
                    }

                });

                /*
                 * Check after login announcement.
                 * NOTICE: The result will be passed through LCMSDK.EventHandler.onAnnouncement(),
                 * whether announcement exists or not ,even check announcement error,
                 * so the following logging in process is done there;
                 * If you do not need to check announcement during login flow, you can log in to
                 * game now.
                 */
                // Start to logging in to game
//                            startToLoggingInToGame();
                LCMSDK.checkAnnouncement();
                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        lastOnSessionError = "";
                        onSessionErrorTextView.setText(lastOnSessionError);
                        onSessionUpdateTextView.setText(lastOnSessionUpdate);
                        logoutBtn.setEnabled(true);
                    }
                });
            }

            /**
             * Triggered when logout completes
             * @param extra
             */
            @Override
            public void onQuitComplete(String extra) {
                SampleActivity.this.finish();
            }
        };

        Map<String, Boolean> map = new HashMap<>();
//        map.put(android.Manifest.permission.READ_PHONE_STATE, true);
        map.put(Manifest.permission.READ_EXTERNAL_STORAGE, false);
//        map.put(Manifest.permission.RECORD_AUDIO, true);
        LCMSDK.registerPermissions(this, map, new LCMSDK.OnRegisterPermissionListener() {
            @Override
            public void onRegisterPermissionsComplete(String... unPermssions) {
                if (unPermssions != null) {
                    for (String str : unPermssions) {
                        Log.i(TAG, "str:" + str);
                    }
                }
                LCMSDK.init(SampleActivity.this, lcmEventHandler);
            }
        });

//        PermissionUtils.getIMEI(this).start(new Callback<String>() {
//            @Override
//            public void onResult(String result) {
//                Log.i(TAG, "imei:" + result);
//            }
//
//            @Override
//            public void onError(Exception e) {
//                Log.e(TAG, e.getMessage(), e);
//            }
//        });
//        PermissionUtils.getIMEI(this).start(new Callback<String>() {
//            @Override
//            public void onResult(String result) {
//                Log.i(TAG, "imei:" + result);
//            }
//
//            @Override
//            public void onError(Exception e) {
//                Log.e(TAG, e.getMessage(), e);
//            }
//        });
//        PermissionUtils.reqestReadPermission(this).start(new Callback<Boolean>() {
//            @Override
//            public void onResult(Boolean result) {
//                Log.i(TAG, "read:" + result);
//            }
//
//            @Override
//            public void onError(Exception e) {
//                Log.e(TAG, e.getMessage(), e);
//            }
//        });

    }

    @Override
    protected void onResume() {
        super.onResume();
        LCMSDK.resume(this);

        onSessionErrorTextView.setText(lastOnSessionError);
        onSessionUpdateTextView.setText(lastOnSessionUpdate);
        onRemoteMessageTextView.setText(lastOnRemoteMessage);

        // Local notification
        LocalNotification localNotification = new LocalNotification(this, 17, 15, "LN new just once", "new shut up", 0);
        LocalNotificationManager.setOnce(this, 1110, localNotification);

        LocalNotification localNotification2 = new LocalNotification(this, 12, 10, "LN new repeat every day", "new shut up", 0);
        LocalNotificationManager.setRepeatingEveryDay(this, 1111, localNotification2);
    }

    @Override
    protected void onRestart() {
        super.onRestart();
        LCMSDK.onRestart(this);
    }

    @Override
    protected void onPause() {
        super.onPause();
        LCMSDK.pause(this);
    }

    @Override
    protected void onStop() {
        super.onStop();
        LCMSDK.onStop(this);
    }

    @Override
    protected void onSaveInstanceState(Bundle outState) {
        super.onSaveInstanceState(outState);
//		LCMSDK.onSaveInstanceState(this, outState);
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        LCMSDK.onActivityResult(this, requestCode, resultCode, data);
    }

    @Override
    protected void onNewIntent(Intent intent) {
        super.onNewIntent(intent);
        LCMSDK.onNewIntent(this, intent);
    }

    /**
     * Called when the activity has detected the user's press of the back
     * key.  The default implementation simply finishes the current activity,
     * but you can override this to do whatever you want.
     */
    @Override
    public void onBackPressed() {
        LCMSDK.quit();
//        new AlertDialog.Builder(SampleActivity.this).setTitle("Info").setMessage("Are you sure to exit?").setPositiveButton("OK", new DialogInterface.OnClickListener() {
//            @Override
//            public void onClick(DialogInterface dialog, int which) {
//
//            }
//        }).setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
//            @Override
//            public void onClick(DialogInterface dialog, int which) {
//                dialog.dismiss();
//            }
//        }).create().show();
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        LCMSDK.onDestroy(this);
        // Kill the process, otherwise, same alliance (such as mzw) may not open login dialog because of singleton
        System.exit(0);
    }

    /**
     * Dismiss OnSessionErrorDialog.</br>
     * </br>
     * Notice: developer should consider where to invoke this method, generally it should be
     * invoked at the beginning of onSessionError/onSessionUpdate/onUpdate/onAnnouncement/onActivation</br>
     * </br>
     * scene:</br>
     * Client retrieve a onSessionError callback, and show the "Network unavailable. Retry?" dialog,
     * user do not click "Yes" nor "No", then lock mobile screen and unlock, at this time, resume
     * will be triggered and get into login flow automatically:</br>
     * (1)if create session successfully, client will retrieve one of
     * onSessionUpdate/onUpdate/onAnnouncement/onActivation, so the OnSessionErrorDialog
     * should be checked and dismissed if is shown.</br>
     * (2)if create session failed(such as user cancel wechat or other autorization), client will
     * retrieve onSessionError again, so the OnSessionErrorDialog should be checked and
     * dismissed if is shown, otherwise, 2 OnSessionErrorDialog will be shown.
     */
    private void dissmissOnSessionErrorDialog() {
        if (sampleOnSessionErrorDialog != null && sampleOnSessionErrorDialog.isShowing()) {
            sampleOnSessionErrorDialog.dismiss();
        }
    }

    private void initView() {
        samplePbDialog = new ProgressDialog(SampleActivity.this, R.getStyle("sampleProgressDialog"));
        samplePbDialog.setCancelable(false);
        samplePbDialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
        samplePbDialog.setOnKeyListener(new DialogInterface.OnKeyListener() {
            @Override
            public boolean onKey(DialogInterface dialog, int keyCode, KeyEvent event) {
                if (keyCode == KeyEvent.KEYCODE_BACK && event.getRepeatCount() == 0) {
                    return true;
                } else {
                    return false;
                }
            }
        });

        onSessionErrorTextView = (TextView) findViewById(R.getId("onSessionError"));
        onSessionUpdateTextView = (TextView) findViewById(R.getId("onSessionUpdate"));
        onRemoteMessageTextView = (TextView) findViewById(R.getId("onRemoteMessage"));
        linkBtn = (Button) findViewById(R.getId("link"));
        linkBtn.setOnLongClickListener(new View.OnLongClickListener() {
            @Override
            public boolean onLongClick(View v) {
                sampleShowPopuwindow(v, R.getString("link_desc"));
                return true;
            }
        });
        linkBtn.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                if (mLinkInfo != null && mLinkInfo.size() > 0) {
                    sampleShowLinkLoadDialog("Link", new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialogInterface,
                                            int which) {
                            Log.d(TAG, mLinkInfo.get(which).getSocialType());
                            /**
                             * Use following code to link account.
                             * SocialInfo is in the linkInfo which is a list.
                             * You must check linkInfo to ensure the link function is supported.
                             */
                            mUser.linkAccount(SampleActivity.this, mLinkInfo.get(which), new LinkAccountCallback() {
                                @Override
                                public void onComplete(String socialType, String socialAccount, LCMError error) {
                                    if (error == null) {
                                        //show UI to tell user link is success.
                                        String msg = "linkAccount success.\nsocialType: "
                                                + socialType
                                                + "\nsocialAccount: "
                                                + socialAccount;
                                        AlertDialog.Builder builder = new AlertDialog.Builder(SampleActivity.this);
                                        builder.setTitle("Link");
                                        builder.setIcon(R.getDrawableForId("ic_launcher"));
                                        builder.setMessage(msg);
                                        builder.create().show();
                                    } else {
                                        //handle error.
                                        String errorMsg = "linkAccount error.\nuserId: " + mUser.getUserId()
                                                + "\nerrorCode: "
                                                + error.getErrorCode()
                                                + "\nerrorMsg: "
                                                + error.getErrorMsg()
                                                + "\nerrorType: "
                                                + error.getErrorType();
                                        Log.e(TAG, errorMsg);

                                        Utils.showLongToastOnUiThread(SampleActivity.this, errorMsg);
                                    }
                                }
                            });
                        }
                    });
                } else {
                    Utils.showLongToastOnUiThread(SampleActivity.this, "No linkInfo loaded.");
                }
            }
        });

        Button loadBtn = (Button) findViewById(R.getId("load"));
        loadBtn.setOnLongClickListener(new View.OnLongClickListener() {
            @Override
            public boolean onLongClick(View v) {
                sampleShowPopuwindow(v, R.getString("load_desc"));
                return true;
            }
        });

        loadBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (mLinkInfo != null && !mLinkInfo.isEmpty()) {
                    sampleShowLinkLoadDialog("Load", new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            final SocialInfo socialInfo = mLinkInfo.get(which);
                            Log.d(TAG, "load:" + socialInfo.getSocialType());
                            if ("oneTimeCode".equals(socialInfo.getSocialType())) {
                                showOneTimeCodeDialog(socialInfo);
                            } else {
                                loadSocials(socialInfo);
                            }
//                            mUser.loadAccount(SampleActivity.this, socialInfo, new LoadAccountCallback() {
//                                @Override
//                                public void onComplete(User afterUser, User beforeUser, String accessToken, LCMError error) {
//                                    if (error == null) {
//                                        //handle the new user.
//                                        Utils.showLongToastOnUiThread(SampleActivity.this, "Load account successed.\nFrom " + beforeUser.getUserId() + " to " + afterUser.getUserId());
//                                        LCMSDK.resume(SampleActivity.this);
//                                        // Update IdBeanList because status in IdBean has changed
//                                        sampleUpdateIdBean();
//                                    } else {
//                                        //handle error.
//                                        Utils.showLongToastOnUiThread(SampleActivity.this, "Load account error.\n" + error.getErrorMsg());
//                                    }
//                                }
//                            });
                        }
                    });
                }
            }
        });

        linkOrLoadBtn = (Button) findViewById(R.getId("linkorload"));
        linkOrLoadBtn.setOnLongClickListener(new View.OnLongClickListener() {
            @Override
            public boolean onLongClick(View v) {
                sampleShowPopuwindow(v, getResources().getString(R.getStringForId("link_or_load_desc")));
                return true;
            }
        });
        linkOrLoadBtn.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                if (mLinkInfo != null && mLinkInfo.size() > 0) {
                    sampleShowLinkLoadDialog("LinkOrLoad", new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialogInterface,
                                            final int which) {
                            Log.d(TAG, mLinkInfo.get(which).getSocialType());
                            /**
                             * Use following code to process linkOrLoad account.
                             * SocialInfo is in the linkInfo which is a list.
                             * You must check linkInfo to ensure the unlink function is supported.
                             */
                            mUser.linkOrLoadAccount(SampleActivity.this, mLinkInfo.get(which), new LinkOrLoadAccountCallback() {
                                @Override
                                public void onComplete(String socialType, String socialAccount, User newUser, User oldUser, String accessToken, LCMError error) {
                                    if (error == null) {
                                        //show UI to tell user link is success.
                                        String msg = "linkOrLoadAccount success.\nsocialType: "
                                                + socialType
                                                + "\nsocialAccount: "
                                                + socialAccount
                                                + "\nnewUser: " + newUser
                                                + "\noldUser: " + oldUser
                                                + "\naccessToken: " + accessToken;
                                        AlertDialog.Builder builder = new AlertDialog.Builder(SampleActivity.this);
                                        builder.setTitle("LinkOrLoad");
                                        builder.setIcon(R.getDrawableForId("ic_launcher"));
                                        builder.setMessage(msg);
                                        builder.create().show();
                                    } else {
                                        //handle error.
                                        String errorMsg = "linkOrLoadAccount error.\nuserId: " + mUser.getUserId()
                                                + "\nerrorCode: "
                                                + error.getErrorCode()
                                                + "\nerrorMsg: "
                                                + error.getErrorMsg()
                                                + "\nerrorType: "
                                                + error.getErrorType();
                                        Log.e(TAG, errorMsg);

                                        Utils.showLongToastOnUiThread(SampleActivity.this, errorMsg);
                                    }
                                }
                            });
                        }
                    });
                } else {
                    Utils.showLongToastOnUiThread(SampleActivity.this, "No linkInfo loaded.");
                }
            }
        });

        unlinkBtn = (Button) findViewById(R.getId("unlink"));
        unlinkBtn.setOnLongClickListener(new View.OnLongClickListener() {
            @Override
            public boolean onLongClick(View v) {
                sampleShowPopuwindow(v, getResources().getString(R.getStringForId("unlink_desc")));
                return true;
            }
        });
        unlinkBtn.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                if (mLinkInfo != null && mLinkInfo.size() > 0) {
                    sampleShowLinkLoadDialog("Unlink", new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialogInterface,
                                            final int which) {
                            Log.d(TAG, mLinkInfo.get(which).getSocialType());
                            /**
                             * Use following code to unlink account.
                             * SocialInfo is in the linkInfo which is a list.
                             * You must check linkInfo to ensure the unlink function is supported.
                             */
                            mUser.unlinkAccount(SampleActivity.this, mLinkInfo.get(which), new UnlinkAccountCallback() {
                                @Override
                                public void onComplete(boolean isSuccess, LCMError error) {
                                    if (isSuccess) {
                                        //show UI to tell user unlink is success.
                                        String msg = "unlinkAccount success.\nsocialType: "
                                                + mLinkInfo.get(which).getSocialType();
                                        AlertDialog.Builder builder = new AlertDialog.Builder(SampleActivity.this);
                                        builder.setTitle("Unlink");
                                        builder.setIcon(R.getDrawableForId("ic_launcher"));
                                        builder.setMessage(msg);
                                        builder.create().show();
                                    } else {
                                        //handle error.
                                        String errorMsg = "unlinkAccount error.\nsocialType: " + mLinkInfo.get(which).getSocialType()
                                                + "\nerrorCode: "
                                                + error.getErrorCode()
                                                + "\nerrorMsg: "
                                                + error.getErrorMsg()
                                                + "\nerrorType: "
                                                + error.getErrorType();
                                        Log.e(TAG, errorMsg);

                                        Utils.showLongToastOnUiThread(SampleActivity.this, errorMsg);
                                    }
                                }
                            });
                        }
                    });
                } else {
                    Utils.showLongToastOnUiThread(SampleActivity.this, "No linkInfo loaded.");
                }
            }
        });

        resetUserBtn = (Button) findViewById(R.getId("resetUser"));
        resetUserBtn.setOnLongClickListener(new View.OnLongClickListener() {
            @Override
            public boolean onLongClick(View v) {
                sampleShowPopuwindow(v, R.getString("reset_user_desc"));
                return true;
            }
        });
        resetUserBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                resetUserBtn.setEnabled(false);
                LCMSDK.resetUser(SampleActivity.this, new OnResetUserComplete() {

                    @Override
                    public void onComplete(User userBefore, User userAfter,
                                           String accessToken, LCMError error) {
                        if (error == null) {

                            resetUserBtn.setEnabled(true);

                            sampleFetchGameInfo();
                            // Update IdBeanList because status in IdBean has changed
                            sampleUpdateIdBean();

                            String decodedAccessToken = null;
                            if (accessToken != null && accessToken.length() > 0) {
                                String[] atArray = accessToken.split("\\.");
                                if (atArray != null && atArray.length == 3) {
                                    try {
                                        String p1 = new String(Base64.decode(atArray[0].getBytes()));
                                        String p2 = new String(Base64.decode(atArray[1].getBytes()));
                                        decodedAccessToken = "\n\ndecodedAccessToken:\n" + p1 + "\n" + p2;
                                    } catch (Base64DecoderException e) {
                                        e.printStackTrace();
                                    }
                                }
                            }
                            lastOnSessionUpdate = "accessToken: " + accessToken + "\n\nuserBefore:\n" + userBefore.toString() + "\n\nuserAfter:\n" + userAfter.toString() + decodedAccessToken;
                            Log.d(TAG, lastOnSessionUpdate);
                            SampleActivity.this.mUser = userAfter;
                            runOnUiThread(new Runnable() {
                                @Override
                                public void run() {
                                    lastOnSessionError = "";
                                    onSessionErrorTextView.setText(lastOnSessionError);
                                    onSessionUpdateTextView.setText(lastOnSessionUpdate);
                                }
                            });
                        } else {
                            resetUserBtn.setEnabled(true);
                            //handle error.
                            lastOnSessionError = "errorCode: " + error.getErrorCode() + "\nerrorMsg: " + error.getErrorMsg() + "\nerrorType: " + error.getErrorType();
                            Log.e(TAG, lastOnSessionError);

                            runOnUiThread(new Runnable() {
                                @Override
                                public void run() {
                                    onSessionErrorTextView.setText(lastOnSessionError);
                                    lastOnSessionUpdate = "";
                                    onSessionUpdateTextView.setText(lastOnSessionUpdate);
                                }
                            });
                        }
                    }
                });
            }
        });

        switchUserBtn = (Button) findViewById(R.getId("switchUser"));
        switchUserBtn.setOnLongClickListener(new View.OnLongClickListener() {
            @Override
            public boolean onLongClick(View v) {
                sampleShowPopuwindow(v, R.getString("switch_user_desc"));
                return true;
            }
        });
        switchUserBtn.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                if (mIdBeanList != null && mIdBeanList.size() > 0) {
                    sampleShowSwitchUserDialog(new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialogInterface,
                                            int which) {
                            Log.d(TAG, mIdBeanList.get(which).toString());
                            /**
                             * Use following code to switch user.
                             * SocialInfo is in the linkInfo which is a list.
                             * You must check linkInfo to ensure the link function is supported.
                             */
                            if (mIdBeanList.get(which).getStatus() == 1) {
                                String msg = "Current user is already " + mIdBeanList.get(which).getLid() + ", no need to switch";
                                Log.e(TAG, msg);
                                Utils.showLongToastOnUiThread(SampleActivity.this, msg);
                                return;
                            }
                            LCMSDK.switchUser(SampleActivity.this, String.valueOf(mIdBeanList.get(which).getLid()), new OnSwitchUserComplete() {
                                @Override
                                public void onComplete(User userBefore,
                                                       User userAfter, String accessToken,
                                                       LCMError error) {
                                    if (error == null) {
                                        // Update IdBeanList because status in IdBean has changed
                                        sampleUpdateIdBean();
                                        //show UI to tell user switch is success.
                                        String msg = "switchUser success.\noldUserId: "
                                                + userBefore.getUserId()
                                                + "\nnewUserId: "
                                                + userAfter.getUserId();
                                        AlertDialog.Builder builder = new AlertDialog.Builder(SampleActivity.this);
                                        builder.setTitle("Switch");
                                        builder.setIcon(R.getDrawableForId("ic_launcher"));
                                        builder.setMessage(msg);
                                        builder.create().show();

                                        String decodedAccessToken = null;
                                        if (accessToken != null && accessToken.length() > 0) {
                                            String[] atArray = accessToken.split("\\.");
                                            if (atArray != null && atArray.length == 3) {
                                                try {
                                                    String p1 = new String(Base64.decode(atArray[0].getBytes()));
                                                    String p2 = new String(Base64.decode(atArray[1].getBytes()));
                                                    decodedAccessToken = "\n\ndecodedAccessToken:\n" + p1 + "\n" + p2;
                                                } catch (Base64DecoderException e) {
                                                    e.printStackTrace();
                                                }
                                            }
                                        }
                                        lastOnSessionUpdate = "accessToken: " + accessToken + "\n\nuserBefore:\n" + userBefore.toString() + "\n\nuserAfter:\n" + userAfter.toString() + decodedAccessToken;
                                        Log.d(TAG, lastOnSessionUpdate);
                                        SampleActivity.this.mUser = userAfter;
                                        runOnUiThread(new Runnable() {
                                            @Override
                                            public void run() {
                                                lastOnSessionError = "";
                                                onSessionErrorTextView.setText(lastOnSessionError);
                                                onSessionUpdateTextView.setText(lastOnSessionUpdate);
                                            }
                                        });

                                        //update data in game_info view.
                                        sampleFetchGameInfo();
                                        sampleUpdateIdBean();
                                    } else {
                                        //handle error.
                                        lastOnSessionError = "errorCode: " + error.getErrorCode() + "\nerrorMsg: " + error.getErrorMsg() + "\nerrorType: " + error.getErrorType();
                                        Log.e(TAG, lastOnSessionError);

                                        runOnUiThread(new Runnable() {
                                            @Override
                                            public void run() {
                                                onSessionErrorTextView.setText(lastOnSessionError);
                                                lastOnSessionUpdate = "";
                                                onSessionUpdateTextView.setText(lastOnSessionUpdate);
                                            }
                                        });
                                    }
                                }
                            });
                        }
                    });
                } else {
                    Utils.showLongToastOnUiThread(SampleActivity.this, "No user loaded.");
                }
            }
        });

        purchaseBtn = (Button) findViewById(R.getId("purchase"));
        purchaseBtn.setOnLongClickListener(new View.OnLongClickListener() {
            @Override
            public boolean onLongClick(View v) {
                sampleShowPopuwindow(v, R.getString("purchase_desc"));
                return true;
            }
        });
        purchaseBtn.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                if (vcBundleList != null && vcBundleList.size() > 0) {
                    if (samplePurchaseDialog == null) {
                        samplePurchaseDialog = new PurchaseDialog(SampleActivity.this);
                    }
                    samplePurchaseDialog.putVCBundleList(vcBundleList);
                    Log.i(TAG, "setText: paid: " + paid + " free: " + free + "");
                    samplePurchaseDialog.setBalanceVisible(SampleActivity.this);

                    samplePurchaseDialog.setItemOnClick(new AdapterView.OnItemClickListener() {
                        @Override
                        public void onItemClick(final AdapterView<?> parent, final View view, int position, long id) {
                            final VCBundle vcBundle = ((ProductItemView) view).getVcBundle();
                            parent.setEnabled(false);
                            if (vcBundle == null) {
                                Log.e(TAG, "vcbundle is null");
                                parent.setEnabled(true);
                                return;
                            }
                            //首先调用接口判断用户是否需要进行实名认证
                            boolean isUserNeedRealNameRegister = LCMSDK.isUserNeedRealNameRegister(SampleActivity.this);
                            if (isUserNeedRealNameRegister) {  // true,表示该用户需要实名认证后才能进行支付操作
                                //do real name auth.
                                LCMSDK.doRealNameAuth(SampleActivity.this, new LCMSDK.OnRealNameListener() {

                                    @Override
                                    public void onComplete(String result, LCMError error) {
                                        if (error == null || error.getErrorCode() == LCMError.ErrorType.REAL_NAME_CANCEL_AND_CAN_SKIP.getErrorCode()) { //got no errors || can skip real name
                                            doPurchase(vcBundle, parent);
                                        }else {
                                            Log.e(TAG, "doRealNameAuth canceled and can not skip.");
                                            Utils.showLongToast(SampleActivity.this, "doRealNameAuth canceled and can not skip.");
                                            parent.setEnabled(true);
                                        }
                                    }
                                });
                            }else {  // false,表示该用户不需要进行实名认证,直接进行支付操作
                                // do purchase.
                                doPurchase(vcBundle, parent);
                            }
                        }
                    });
                    samplePurchaseDialog.show();
                } else {
                    Utils.showLongToast(SampleActivity.this, "no vcbundles.");
                }
            }
        });

        exitBtn = (Button) findViewById(R.getId("exit"));
        exitBtn.setOnLongClickListener(new View.OnLongClickListener() {
            @Override
            public boolean onLongClick(View v) {
                sampleShowPopuwindow(v, R.getString("exit_desc"));
                return true;
            }
        });
        exitBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                LCMSDK.quit();
            }
        });

        logoutBtn = (Button) findViewById(R.getId("logout"));
        logoutBtn.setOnLongClickListener(new View.OnLongClickListener() {
            @Override
            public boolean onLongClick(View v) {
                sampleShowPopuwindow(v, R.getString("logout_desc"));
                return true;
            }
        });
        logoutBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                logoutBtn.setEnabled(false);
                LCMSDK.logout();
            }
        });
        findViewById(R.getId("itemLost")).setOnLongClickListener(new View.OnLongClickListener() {
            @Override
            public boolean onLongClick(View v) {
                sampleShowPopuwindow(v, R.getString("item_lost_desc"));
                return true;
            }
        });
        findViewById(R.getId("itemLost")).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (lostVcBundleList != null && lostVcBundleList.size() > 0) {
                    List<VCBundle> vbs = new ArrayList<VCBundle>();
                    for (SampleLostVCBundle lb : lostVcBundleList) {
                        vbs.add(lb.vcBundle);
                    }
                    sampleShowBundleList("Items lost", vbs, new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            sampleSendProps(lostVcBundleList.get(which));
                            dialog.dismiss();
                        }
                    });
                } else {
                    Toast.makeText(SampleActivity.this, "You have no item lost.", Toast.LENGTH_LONG).show();
                }
            }
        });

        findViewById(R.getId("showCs")).setOnLongClickListener(new View.OnLongClickListener() {
            @Override
            public boolean onLongClick(View v) {
                sampleShowPopuwindow(v, R.getString("cs_desc"));
                return true;
            }
        });
        findViewById(R.getId("showCs")).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                LCMSDK.showCS(SampleActivity.this);
            }
        });

        setExtraBtn = (Button) findViewById(R.getId("setExtra"));
        setExtraBtn.setOnLongClickListener(new View.OnLongClickListener() {
            @Override
            public boolean onLongClick(View v) {
                sampleShowPopuwindow(v, R.getString("extra_desc"));
                return true;
            }
        });
        setExtraBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //CreateRole Event
                String event = "CreateRole";
                HashMap<String, Object> infoMap = new HashMap<String, Object>();
                infoMap.put("roleId", "13524696");
                infoMap.put("roleName", "方木");
                infoMap.put("roleLevel", "24");
                infoMap.put("zoneId", "1");
                infoMap.put("zoneName", "墨土1区");
                infoMap.put("partyName", "公会1");
                infoMap.put("vip", "2");
                infoMap.put("balance", "2");
                infoMap.put("createRoleTime", String.valueOf(System.currentTimeMillis()));
                JSONObject jsonExtraData = new JSONObject(infoMap);
                LCMSDK.setExtra(event, jsonExtraData.toString());

                //StartPlay Event
                String event2 = "StartPlay";
                LCMSDK.setExtra(event2, jsonExtraData.toString());

                Toast.makeText(SampleActivity.this, "you have pushed the setExtra Button!", Toast.LENGTH_LONG).show();
            }
        });

        menubarBtn = (Button) findViewById(R.getId("menubar"));
        menubarBtn.setOnLongClickListener(new View.OnLongClickListener() {
            @Override
            public boolean onLongClick(View v) {
                sampleShowPopuwindow(v, R.getString("menubar_desc"));
                return true;
            }
        });
        menubarBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(final View view) {
                final LinearLayout layout = new MenubarView(SampleActivity.this);
                final PopupWindow window = new PopupWindow(layout, WindowManager.LayoutParams.WRAP_CONTENT, WindowManager.LayoutParams.WRAP_CONTENT, true);
                window.setOutsideTouchable(true);
                window.setBackgroundDrawable(new BitmapDrawable(getResources(), (Bitmap) null));
                final ArrowView arrowView = (ArrowView) layout.findViewById(R.getId("des_arrow"));

                final int[] local = new int[2];
                view.getLocationInWindow(local);
                if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.KITKAT) {
                    window.getContentView().measure(0, 0);
                }
                Log.i(TAG, "local[0]:" + local[0] + "   local[1]:" + local[1]);
                ViewTreeObserver vto2 = arrowView.getViewTreeObserver();
                vto2.addOnGlobalLayoutListener(new ViewTreeObserver.OnGlobalLayoutListener() {
                    @Override
                    public void onGlobalLayout() {
                        arrowView.getViewTreeObserver().removeGlobalOnLayoutListener(this);
                        Log.i(TAG, "arrowWidth:" + arrowView.getWidth());
                        int screenWidth = getWindow().getWindowManager().getDefaultDisplay().getWidth();
                        int windowHeight = layout.getHeight();
                        int windowWidth = layout.getWidth();
                        int buttonWidth = view.getWidth();
                        Log.i(TAG, "windowWidth:" + windowWidth + "   windowHeight:" + windowHeight + "   screenWidth:" + screenWidth);
                        int left = local[0] + buttonWidth / 2 - windowWidth / 2;
                        Log.i(TAG, "left:" + left);
                        if (left < 10) {
                            left = 10;
                        }
                        Log.i(TAG, "left:" + left);
                        int top = local[1] - windowHeight;

                        LinearLayout.LayoutParams lp = (LinearLayout.LayoutParams) arrowView.getLayoutParams();
                        int arrowWidth = arrowView.getWidth();
                        Log.i(TAG, "arrowWidth:" + arrowWidth);
                        if (left + windowWidth > screenWidth - 10) {
                            left = screenWidth - windowWidth - 10;
                            buttonWidth = screenWidth - local[0];
                        }
                        lp.leftMargin = local[0] - left + buttonWidth / 2 - arrowWidth / 2;
                        Log.i(TAG, "local:" + local[0] + "  left:" + left + "  btnwidth:" + buttonWidth + "  arrowWidth:" + arrowView.getWidth());
                        window.update(left, top, windowWidth, windowHeight);
                    }
                });
                window.showAtLocation(view, Gravity.TOP | Gravity.LEFT, 0, 0);
            }
        });

        findViewById(R.getId("getAffcode")).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                String affcode = LCMSDK.getAffcode();
                Toast.makeText(SampleActivity.this, "affcode is " + affcode, Toast.LENGTH_SHORT).show();
            }
        });

        findViewById(R.getId("additionFunction")).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                LCMSDK.additionalFunction(SampleActivity.this, LCMSDK.LCMAdditionalFunction.STORE_ACCOUNT_MANAGER);
            }
        });
    }

    /**
     * Start to logging in to game
     */
    private void sampleStartToLoggingInToGame() {
        isFirstToLinkOrLoad = lcmApplication.isFirstToLinkOrLoad();
        if (isFirstToLinkOrLoad) {
            sampleShowFirstLaunchPage();
        } else {
            sampleFirstlLoggingInToGame();
        }
    }

    private void sampleFirstlLoggingInToGame() {
        sampleHideSplash();
        VCBundle.getAsList(SampleActivity.this, new VCBundleCallback() {
            @Override
            public void onComplete(List<VCBundle> bundles, LCMError error) {
                if (error == null) {
                    //save them.
                    vcBundleList = bundles;
                    // Recovery
                    LCMSDK.recover(SampleActivity.this, vcBundleList);
                } else {
                    //handle error.
                    Toast.makeText(SampleActivity.this, "getVCBundles error, " + error.getErrorMsg(), Toast.LENGTH_LONG).show();
                }
            }
        });
        LayoutInflater inflater1 = (LayoutInflater) SampleActivity.this.getSystemService(LAYOUT_INFLATER_SERVICE);
        sampleGameInfoView = inflater1.inflate(R.getLayoutForId("game_info"), null);
        FrameLayout.LayoutParams params = new FrameLayout.LayoutParams(screenWidth / 3, (int) ((screenWidth / 3) * (7.0 / 9)));
        params.gravity = Gravity.TOP | Gravity.RIGHT;
        SampleActivity.this.addContentView(sampleGameInfoView, params);
        sampleUpdateBalance();

        sampleFetchGameInfo();

        sampleUpdateIdBean();
    }

    private void sampleHideSplash() {
//        final Animation fadeOut = new AlphaAnimation(1.0f, 0.0f);
//        fadeOut.setDuration(1000);
//        fadeOut.setAnimationListener(new Animation.AnimationListener() {
//            @Override
//            public void onAnimationStart(Animation animation) {
//
//            }
//
//            @Override
//            public void onAnimationEnd(Animation animation) {
//                ((ViewGroup) sampleSplashView.getParent()).removeView(sampleSplashView);
//                if (!isFirstToLinkOrLoad) {
//                    //隐藏play load窗口
////                    showPlayDialog();
//                }
//            }
//
//            @Override
//            public void onAnimationRepeat(Animation animation) {
//
//            }
//        });
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
//                sampleSplashView.startAnimation(fadeOut);
                ViewGroup vg = (ViewGroup) sampleSplashView.getParent();
                if (vg != null) {
                    vg.removeView(sampleSplashView);
                }
            }
        });
    }

    private void sampleShowLinkLoadDialog(String title, DialogInterface.OnClickListener listener) {
        AlertDialog.Builder builder = new AlertDialog.Builder(SampleActivity.this);
        builder.setTitle(title);
        builder.setIcon(R.getDrawableForId("ic_launcher"));
        CharSequence[] cs = new CharSequence[mLinkInfo.size()];
        for (int i = 0; i < mLinkInfo.size(); i++) {
            cs[i] = mLinkInfo.get(i).getSocialType();
        }
        builder.setItems(cs, listener);
        builder.create().show();
    }

    private void sampleShowBundleList(String title, List<VCBundle> bundles, DialogInterface.OnClickListener listener) {
        AlertDialog.Builder builder = new AlertDialog.Builder(SampleActivity.this);
        builder.setTitle(title);
        builder.setIcon(R.getDrawableForId("ic_launcher"));
        CharSequence[] cs = new CharSequence[bundles.size()];
        for (int i = 0; i < bundles.size(); i++) {
            cs[i] = bundles.get(i).getSku();
        }
        builder.setItems(cs, listener);
        builder.create().show();
    }

    private void sampleShowPlayDialog() {
        final Dialog dialog = new Dialog(SampleActivity.this, R.getStyle("playDialog"));
        //设置它的ContentView
        dialog.setContentView(R.getLayoutForView("play_dialog"));
        Window dialogWindow = dialog.getWindow();
        WindowManager.LayoutParams lp = dialogWindow.getAttributes();
        dialogWindow.setGravity(Gravity.CENTER);//设置显示位置
        int width = (int) (screenWidth / 1.2);
        dialog.setCancelable(false);
        dialog.setCanceledOnTouchOutside(false);
        dialog.show();
        dialogWindow.setLayout(width, width);//设置宽高
        dialog.getWindow().findViewById(R.getId("load")).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View arg0) {
                sampleShowLinkLoadDialog("Load", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        if (mLinkInfo != null && mLinkInfo.size() > 0) {
                            final SocialInfo si = mLinkInfo.get(which);
                            if ("oneTimeCode".equalsIgnoreCase(si.getSocialType())) {
                                final EditText oneTimeCodeInput = new EditText(SampleActivity.this);
                                new AlertDialog.Builder(SampleActivity.this).setTitle("Please input oneTimeCode").setIcon(R.getDrawableForId("ic_launcher")).setView(oneTimeCodeInput).setPositiveButton("OK", new DialogInterface.OnClickListener() {
                                    @Override
                                    public void onClick(DialogInterface dialog, int which) {
                                        //get one time code.
                                        String oneTimeCode = oneTimeCodeInput.getText().toString();
                                        //set the code in social info.
                                        si.setSocialAccount(oneTimeCode);
                                        /**
                                         * Use one time code to load account.
                                         * Social info is from the first step you get linkInfo list.
                                         */
                                        mUser.loadAccount(SampleActivity.this, si, new LoadAccountCallback() {
                                            @Override
                                            public void onComplete(User afterUser, User beforeUser, String accessToken, LCMError error) {
                                                if (error == null) {
                                                    //handle the new user.
                                                    Utils.showLongToastOnUiThread(SampleActivity.this, "Load account successed.\nFrom " + beforeUser.getUserId() + " to " + afterUser.getUserId());
                                                    LCMSDK.resume(SampleActivity.this);
                                                    // Update IdBeanList because status in IdBean has changed
                                                    sampleUpdateIdBean();
                                                    sampleFetchGameInfo();
                                                } else {
                                                    //handle error.
                                                    Utils.showLongToastOnUiThread(SampleActivity.this, "Load account error.\n" + error.getErrorMsg());
                                                }
                                            }
                                        });
                                    }
                                }).setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
                                    @Override
                                    public void onClick(DialogInterface dialog, int which) {
                                        dialog.dismiss();
                                    }
                                }).show();
                            } else {
                                /**
                                 * Use social account to load.
                                 * Social info is from the first step you get linkInfo list.
                                 */
                                mUser.loadAccount(SampleActivity.this, si, new LoadAccountCallback() {
                                    @Override
                                    public void onComplete(User newUser, User oldUser, String accessToken, LCMError error) {
                                        if (error == null) {
                                            //handle the new user.
                                            Utils.showLongToastOnUiThread(SampleActivity.this, "Load account successed.\nFrom " + oldUser.getUserId() + " to " + newUser.getUserId());
                                            LCMSDK.resume(SampleActivity.this);
                                        } else {
                                            //handle error.
                                            Utils.showLongToastOnUiThread(SampleActivity.this, "Load account error.\n" + error.getErrorMsg());
                                        }
                                    }
                                });
                            }
                        } else {
                            Utils.showLongToastOnUiThread(SampleActivity.this, "No loadInfo loaded.");
                        }
                    }
                });
            }
        });
        dialog.getWindow().findViewById(R.getId("play")).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                dialog.dismiss();
            }
        });
    }

    private void sampleShowFirstLaunchPage() {
        final Dialog dialog = new Dialog(SampleActivity.this, R.getStyle("playDialog"));
        //设置它的ContentView
        dialog.setContentView(R.getLayoutForView("first_launch_page_dialog"));
        Window dialogWindow = dialog.getWindow();
        WindowManager.LayoutParams lp = dialogWindow.getAttributes();
        dialogWindow.setGravity(Gravity.CENTER);//设置显示位置
        int width = (int) (screenWidth / 1.2);
        dialog.setCancelable(false);
        dialog.setCanceledOnTouchOutside(false);
        dialog.show();
        dialogWindow.setLayout(width, width);//设置宽高
        if (mLinkInfo != null) {
            for (int i = 0; i < mLinkInfo.size(); i++) {
                final SocialInfo linkInfo = mLinkInfo.get(i);
                if ("facebook".equalsIgnoreCase(linkInfo.getSocialType())) {
                    View btn = dialog.getWindow().findViewById(R.getId("facebook"));
                    btn.setVisibility(View.VISIBLE);
                    btn.setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View v) {
                            /**
                             * Use following code to process linkOrLoad account.
                             * SocialInfo is in the linkInfo which is a list.
                             * You must check linkInfo to ensure the unlink function is supported.
                             */
                            mUser.linkOrLoadAccount(SampleActivity.this, linkInfo, new LinkOrLoadAccountCallback() {
                                @Override
                                public void onComplete(String socialType, String socialAccount, User newUser, User oldUser, String accessToken, LCMError error) {
                                    if (error == null) {
                                        String msg = "linkOrLoadAccount success.\nsocialType: "
                                                + socialType
                                                + "\nsocialAccount: "
                                                + socialAccount
                                                + "\nnewUser: " + newUser
                                                + "\noldUser: " + oldUser
                                                + "\naccessToken: " + accessToken;
                                        Log.d(TAG, msg);

                                        dialog.dismiss();
                                        sampleFirstlLoggingInToGame();
                                    } else {
                                        //handle error.
                                        String errorMsg = "linkOrLoadAccount error.\nuserId: " + mUser.getUserId()
                                                + "\nerrorCode: "
                                                + error.getErrorCode()
                                                + "\nerrorMsg: "
                                                + error.getErrorMsg()
                                                + "\nerrorType: "
                                                + error.getErrorType();
                                        Log.e(TAG, errorMsg);

                                        Utils.showLongToastOnUiThread(SampleActivity.this, errorMsg);
                                    }
                                }
                            });
                        }
                    });
                }
            }
        }
    }

    /**
     * Sample that tells developer how to make a customize force update UI
     *
     * @param lcmUpdater
     */
    private void sampleShowUpdateDialog(final LCMUpdater lcmUpdater) {
        String description = lcmUpdater.getDescription();
        final boolean canSkip = lcmUpdater.isCanSkip();
        final AlertDialog.Builder builder = new AlertDialog.Builder(SampleActivity.this);
        builder.setTitle("Update");
        builder.setMessage(description);
        builder.setIcon(R.getDrawableForId("ic_launcher"));
        if (canSkip) {
            builder.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int which) {
                    //skip update
                    lcmUpdater.continueProcessing();
                }
            });
        }
        builder.setPositiveButton("Update", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                // Can login if it is not force update
                if (canSkip) {
                    lcmUpdater.continueProcessing();
                }
                lcmUpdater.download(new ProcessChangeListener() {

                    @Override
                    public void onProcessChange(long totalSize, long currentSize) {
                        Log.d(TAG, "downloading. currentSize: " + currentSize + "; totalSize: " + totalSize);
                        //show your process ui
                        //handle when download complete
                        if (currentSize == 0) {
                            Utils.showLongToastOnUiThread(SampleActivity.this, "Start downloading. \nTotalSize: " + totalSize);
                        }
                        if (currentSize != 0 && currentSize < totalSize) {
                            // Update UI
                        }
                        if (totalSize == currentSize) {
                            boolean isOk = lcmUpdater.checkMd5();
                            if (isOk) {
                                Utils.showLongToastOnUiThread(SampleActivity.this, "Complete downloading. \nTotalSize: " + totalSize);
                                lcmUpdater.install(SampleActivity.this);
                            } else {
                                Utils.showLongToastOnUiThread(SampleActivity.this, "Error check MD5.");
                                //download again.
                            }
                        }
                    }

                    @Override
                    public void onError(LCMError error) {
                        Log.e(TAG, "download error. " + error.toString());
                        Utils.showLongToastOnUiThread(SampleActivity.this, error.toString());
                        finish();
                    }

                });
            }
        });
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                AlertDialog dialog = builder.create();
                dialog.setCancelable(false);
                dialog.show();
            }
        });
    }

    private void sampleShowSwitchUserDialog(DialogInterface.OnClickListener listener) {
        AlertDialog.Builder builder = new AlertDialog.Builder(SampleActivity.this);
        builder.setTitle("SwitchUser");
        builder.setIcon(R.getDrawableForId("ic_launcher"));
        CharSequence[] cs = new CharSequence[mIdBeanList.size()];
        for (int i = 0; i < mIdBeanList.size(); i++) {
            cs[i] = String.valueOf(mIdBeanList.get(i).getLid()) + " , " + (mIdBeanList.get(i).getStatus() == 0 ? "unactive" : "active");
        }
        builder.setItems(cs, listener);
        builder.create().show();
    }

    private void sampleFetchGameInfo() {
        String url = "http://lcm.pickle.mbgadev.cn/users/auth/create";
        url += "?isSandbox=" + lcmApplication.loadAppInfo().get(LCMSDK.AppInfoKeyEnum.SANDBOX);
        url += "&env=" + lcmApplication.loadAppInfo().get(LCMSDK.AppInfoKeyEnum.ENV);
        url += "&region=" + lcmApplication.loadAppInfo().get(LCMSDK.AppInfoKeyEnum.REGION);
        LCMStringRequest request = new LCMStringRequest(url, new Response.Listener<String>() {
            @Override
            public void onResponse(String response) {
                Log.i(TAG, "fetch game info success. response=" + response);

                try {
                    JSONObject jo = new JSONObject(response);
                    String playerId = jo.optString("player_id");
                    String coin = jo.optString("coin");
                    myEnv = jo.optString("myEnv");
                    if (sampleGameInfoView != null) {
                        ((TextView) sampleGameInfoView.findViewById(R.getId("gameIdTxt"))).setText(playerId);
                        ((TextView) sampleGameInfoView.findViewById(R.getId("coinTxt"))).setText(coin);
                    }

                } catch (JSONException e) {
                    Log.e(TAG, "can not parse json", e);
                }
            }
        }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {
                Log.e(TAG, "fetch game info error", error);
            }
        });

        VolleyManager.getInstance(this).onRunHttp(request);
    }

    /**
     * 下发道具
     *
     * @param vcBundle
     * @param orderId
     */
    private void sampleSendProps(final VCBundle vcBundle, final String orderId) {
        String url = "http://lcm.pickle.mbgadev.cn/users/coin/purchase";
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("sku", vcBundle.getSku());
        params.put("order_id", orderId);
        params.put("quantity_num", "1");
        params.put("myEnv", myEnv);
        // Use L coin
        params.put("needBalance", L_COIN_SWITCHER);
        JSONObject json = new JSONObject(params);
        LCMJsonObjectRequest request = new LCMJsonObjectRequest(Request.Method.POST, url, json, new Response.Listener<JSONObject>() {

            @Override
            public void onResponse(JSONObject response) {
                Log.i(TAG, "spend response:" + response);
                sampleUpdateBalance();
                ((TextView) sampleGameInfoView
                        .findViewById(R.getId("coinTxt"))).setText(String.valueOf(response.optInt("coin")));
                if (samplePbDialog != null) {
                    samplePbDialog.dismiss();
                }
                Toast.makeText(SampleActivity.this, "spend success, resp: " + response, Toast.LENGTH_LONG).show();
            }
        }, new Response.ErrorListener() {

            @Override
            public void onErrorResponse(VolleyError error) {
                Log.e(TAG, "spend error", error);
                Toast.makeText(SampleActivity.this, "spend error, error: " + error.getMessage(), Toast.LENGTH_LONG).show();
                if (lostVcBundleList == null) {
                    lostVcBundleList = new ArrayList<SampleLostVCBundle>();
                }
                if (samplePbDialog != null) {
                    samplePbDialog.dismiss();
                }
                lostVcBundleList.add(new SampleLostVCBundle(vcBundle, orderId));
//                saveLostVcBundleList();
            }
        });

        VolleyManager.getInstance(this).onRunHttp(request);
    }

    /**
     * 发道具
     *
     * @param lostVCBundle
     */
    private void sampleSendProps(final SampleLostVCBundle lostVCBundle) {
        String url = "http://lcm.pickle.mbgadev.cn/users/coin/purchase";
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("sku", lostVCBundle.vcBundle.getSku());
        params.put("order_id", lostVCBundle.orderId);
        params.put("quantity_num", "1");
        params.put("myEnv", myEnv);
        // Use L coin
        params.put("needBalance", L_COIN_SWITCHER);
        JSONObject json = new JSONObject(params);
        LCMJsonObjectRequest request = new LCMJsonObjectRequest(Request.Method.POST, url, json, new Response.Listener<JSONObject>() {

            @Override
            public void onResponse(JSONObject response) {
                Log.i(TAG, "spend response:" + response);
                ((TextView) sampleGameInfoView
                        .findViewById(R.getId("coinTxt"))).setText(String.valueOf(response.optInt("coin")));
                Toast.makeText(SampleActivity.this, "spend success, resp: " + response, Toast.LENGTH_LONG).show();
                lostVcBundleList.remove(lostVCBundle);
            }
        }, new Response.ErrorListener() {

            @Override
            public void onErrorResponse(VolleyError error) {
                Log.e(TAG, "spend error", error);
                Toast.makeText(SampleActivity.this, "spend error, error: " + error.getMessage(), Toast.LENGTH_LONG).show();
            }
        });
        request.setRetryPolicy(new DefaultRetryPolicy(5000, 0, 0));
        VolleyManager.getInstance(this).onRunHttp(request);
    }


    class SampleLostVcBundleListBean implements Serializable {
        private static final long serialVersionUID = 1420672609912364060L;
        private List<SampleLostVCBundle> lostVcBundleList;

        public List<SampleLostVCBundle> getLostVcBundleList() {
            return lostVcBundleList;
        }

        public void setLostVcBundleList(List<SampleLostVCBundle> lostVcBundleList) {
            this.lostVcBundleList = lostVcBundleList;
        }
    }

    private void sampleSaveLostVcBundleList() {
        SharedPreferences mSharedPreferences = getSharedPreferences("pickle", MODE_PRIVATE);
        SampleLostVcBundleListBean lb = new SampleLostVcBundleListBean();
        lb.setLostVcBundleList(lostVcBundleList);
        try {
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            ObjectOutputStream oos = new ObjectOutputStream(baos);
            oos.writeObject(lb);

            String vcBundleListBase64 = new String(Base64.encode(baos.toByteArray()));
            SharedPreferences.Editor editor = mSharedPreferences.edit();
            editor.putString("vcBundleList", vcBundleListBase64);
            editor.commit();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    protected List<SampleLostVCBundle> sampleGetLostVcBundleList() {
        List<SampleLostVCBundle> vcBundleList = new ArrayList<SampleLostVCBundle>();
        try {
            SharedPreferences mSharedPreferences = getSharedPreferences("pickle", MODE_PRIVATE);
            String vcBundleListBase64 = mSharedPreferences.getString("vcBundleList", "");
            byte[] base64Bytes = Base64.decode(vcBundleListBase64.getBytes());
            ByteArrayInputStream bais = new ByteArrayInputStream(base64Bytes);
            ObjectInputStream ois = new ObjectInputStream(bais);
            SampleLostVcBundleListBean lb = (SampleLostVcBundleListBean) ois.readObject();
            vcBundleList = lb.getLostVcBundleList();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return vcBundleList;
    }

    private class SampleLostVCBundle {
        private VCBundle vcBundle;
        private String orderId;

        public SampleLostVCBundle(VCBundle vcBundle, String orderId) {
            this.vcBundle = vcBundle;
            this.orderId = orderId;
        }
    }

    private void sampleUpdateBalance() {
        Wallet.getCurrentBalance(SampleActivity.this, new WalletCallback() {
            @Override
            public void onComplete(Wallet wallet, LCMError error) {
                Log.d(TAG, "getCurrentBalance complete");
                if (error == null) {
                    Log.d(TAG, "wallet,wallet: " + wallet);
                    sampleSavePaidAndFree(String.valueOf(wallet.getPaidBalance()), String.valueOf(wallet.getFreeBalance()));
                } else {
                    Log.e(TAG, "LCMError: " + error);
                    Utils.showLongToast(getApplicationContext(), "get current balance error.\n" + error.toString());
                }
            }
        });
    }

    /**
     * Update IdBean of the current user
     */
    private void sampleUpdateIdBean() {
        // Update IdBeanList because status in IdBean has changed
        Log.d(TAG, "Update IdBeanList because status in IdBean has changed");
        LCMSDK.getAllUserIds(SampleActivity.this, new OnGetAllUserIdsComplete() {
            @Override
            public void onComplete(List<IdBean> idBeanList,
                                   LCMError error) {
                if (error == null) {
                    //save them.
                    mIdBeanList = idBeanList;
                } else {
                    //handle error.
                    Toast.makeText(SampleActivity.this, "getAllUserIds error, " + error.getErrorMsg(), Toast.LENGTH_LONG).show();
                }
            }

        });
    }

    private void sampleSavePaidAndFree(String paid, String free) {
        this.paid = paid;
        this.free = free;
        if (samplePurchaseDialog != null) {
            samplePurchaseDialog.setPaidText(paid);
            samplePurchaseDialog.setFreeText(free);
        }
    }

    private void sampleShowPopuwindow(final View view, String str) {
        final View v = getLayoutInflater().inflate(R.getLayoutForId("popu_view_layout"), null);
        final PopupWindow window = new PopupWindow(v, WindowManager.LayoutParams.WRAP_CONTENT, WindowManager.LayoutParams.WRAP_CONTENT, true);
        window.setOutsideTouchable(true);
        window.setBackgroundDrawable(new BitmapDrawable(getResources(), (Bitmap) null));
        final ArrowView arrowView = (ArrowView) v.findViewById(R.getId("des_arrow"));
        TextView textView = (TextView) v.findViewById(R.getId("des_txt"));
        if (textView != null && !TextUtils.isEmpty(str)) {
            textView.setText(str);
        }
        final int[] local = new int[2];
        view.getLocationInWindow(local);
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.KITKAT) {
            window.getContentView().measure(0, 0);
        }
        Log.i(TAG, "local[0]:" + local[0] + "   local[1]:" + local[1]);
        ViewTreeObserver vto2 = arrowView.getViewTreeObserver();
        vto2.addOnGlobalLayoutListener(new ViewTreeObserver.OnGlobalLayoutListener() {
            @Override
            public void onGlobalLayout() {
                arrowView.getViewTreeObserver().removeGlobalOnLayoutListener(this);
                Log.i(TAG, "arrowWidth:" + arrowView.getWidth());
                int screenWidth = getWindow().getWindowManager().getDefaultDisplay().getWidth();
                int windowHeight = v.getHeight();
                int windowWidth = v.getWidth();
                int buttonWidth = view.getWidth();
                Log.i(TAG, "windowWidth:" + windowWidth + "   windowHeight:" + windowHeight + "   screenWidth:" + screenWidth);
                int left = local[0] + buttonWidth / 2 - windowWidth / 2;
                Log.i(TAG, "left:" + left);
                if (left < 10) {
                    left = 10;
                }
                Log.i(TAG, "left:" + left);
                int top = local[1] - windowHeight;

                RelativeLayout.LayoutParams lp = (RelativeLayout.LayoutParams) arrowView.getLayoutParams();
                int arrowWidth = arrowView.getWidth();
                Log.i(TAG, "arrowWidth:" + arrowWidth);
                if (left + windowWidth > screenWidth - 10) {
                    left = screenWidth - windowWidth - 10;
                    buttonWidth = screenWidth - local[0];
                }
                lp.leftMargin = local[0] - left + buttonWidth / 2 - arrowWidth / 2;
                Log.i(TAG, "local:" + local[0] + "  left:" + left + "  btnwidth:" + buttonWidth + "  arrowWidth:" + arrowView.getWidth());
                window.update(left, top, windowWidth, windowHeight);
            }
        });
        window.showAtLocation(view, Gravity.TOP | Gravity.LEFT, 0, 0);
    }

    @Override
    public void onConfigurationChanged(Configuration newConfig) {
        super.onConfigurationChanged(newConfig);
        LCMSDK.onConfigurationChanged(this, newConfig);
    }

    private void showOneTimeCodeDialog(final SocialInfo socialInfo) {
        View view = getLayoutInflater().inflate(R.getLayoutForId("dialog_one_time_code_dialog"), null);
        AlertDialog.Builder builder = new AlertDialog.Builder(this);
        builder.setTitle(R.getString("one_time_code_title"));
        builder.setView(view);
        final AlertDialog dialog = builder.create();
        final EditText textView = (EditText) view.findViewById(R.getId("code_text"));
        view.findViewById(R.getId("cancel_btn")).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                dialog.dismiss();
            }
        });
        view.findViewById(R.getId("ok_btn")).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                String oneTimeCode = textView.getText().toString().trim();
                if (TextUtils.isEmpty(oneTimeCode)) {
                    Toast.makeText(SampleActivity.this, "one time code is empty", Toast.LENGTH_SHORT).show();
                    return;
                }
                socialInfo.setSocialAccount(oneTimeCode);
                loadSocials(socialInfo);
                dialog.dismiss();
            }
        });
        dialog.show();
    }

    private void loadSocials(SocialInfo socialInfo) {
        mUser.loadAccount(SampleActivity.this, socialInfo, new LoadAccountCallback() {
            @Override
            public void onComplete(User afterUser, User beforeUser, String accessToken, LCMError error) {
                if (error == null) {
                    //handle the new user.
                    Utils.showLongToastOnUiThread(SampleActivity.this, "Load account successed.\nFrom " + beforeUser.getUserId() + " to " + afterUser.getUserId());
                    LCMSDK.resume(SampleActivity.this);
                    // Update IdBeanList because status in IdBean has changed
                    sampleUpdateIdBean();

                    // Update Game Info.
                    sampleFetchGameInfo();
                } else {
                    //handle error.
                    Utils.showLongToastOnUiThread(SampleActivity.this, "Load account error.\n" + error.getErrorMsg());
                }
            }
        });
    }

    public void onRequestPermissionsResult(int requestCode, String[] permissions, int[] grantResults) {
        LCMSDK.onRequestPermissionsResult(requestCode, permissions, grantResults);
    }

    public void doPurchase(final VCBundle vcBundle, final AdapterView<?> parent) {
        samplePbDialog.show();
        Wallet.getCurrentBalance(SampleActivity.this, new WalletCallback() {
            @Override
            public void onComplete(Wallet wallet, LCMError error) {
                Log.d(TAG, "getCurrentBalance complete");
                if (error == null) {
                    Log.d(TAG, "wallet,wallet: " + wallet);
                    sampleSavePaidAndFree(String.valueOf(wallet.getPaidBalance()), String.valueOf(wallet.getFreeBalance()));
                    //start purchase
                    Log.d(TAG, "Starting purchase: " + vcBundle.getSku());
                    String purchaseMemo = "Test memo";
                    /**
                     * vcBundle can be found in vcBundle list.
                     */

                    int totalBalance = wallet.getPaidBalance() + wallet.getFreeBalance();
                    Log.i(TAG, "totalBalance: " + totalBalance + "");
                    if (totalBalance < vcBundle.getValue()) {
                        vcBundle.purchase(SampleActivity.this, purchaseMemo, new VCBundle.PurchaseCallback() {

                            @Override
                            public void onComplete(Wallet wallet, JSONObject payInfo, String memo, LCMError error) {
                                String msg;
                                parent.setEnabled(true);
                                // Purchase error
                                if (error != null) {
                                    msg = "Purchase error. \nerror: " + error;
                                    Log.e(TAG, msg);
                                    if (samplePbDialog != null) {
                                        samplePbDialog.dismiss();
                                    }
                                    // Show Dialog to tell user to login to google account
                                    if (error.getErrorType() == LCMError.ErrorType.BANK_PURCHASE_NO_GOOGLE_ACCOUNT) {
                                        AlertDialog.Builder builder = new AlertDialog.Builder(SampleActivity.this);
                                        builder.setTitle("no google account");
                                        builder.setMessage("no google account, please login google account");
                                        builder.setPositiveButton("OK", new DialogInterface.OnClickListener() {
                                            @Override
                                            public void onClick(DialogInterface dialog, int which) {
                                                dialog.dismiss();
                                            }
                                        });
                                        builder.show();
                                        return;
                                    } else {
                                        // Other error, do your process
                                    }
                                }
                                // Purchase success
                                else {
                                    //handle success.
                                    sampleSavePaidAndFree(String.valueOf(wallet.getPaidBalance()), String.valueOf(wallet.getFreeBalance()));
                                    //IMPORTANT!!!
                                    //call game server to spend L coin.
                                    String orderId = null;
                                    String payType = null;
                                    if (payInfo != null) {
                                        orderId = payInfo.optString("orderId");
                                        payType = payInfo.optString("payType");
                                    }
                                    sampleSendProps(vcBundle, orderId);
                                    msg = "Purchase success. \npaidBalance: "
                                            + wallet.getPaidBalance()
                                            + "\nfreeBalance: "
                                            + wallet.getFreeBalance()
                                            + "\ncurrency: "
                                            + wallet.getCurrency()
                                            + "\norderId: "
                                            + orderId
                                            + "\npayType: "
                                            + payType;
                                    Log.d(TAG, msg);
                                }
                                Utils.showLongToast(SampleActivity.this, msg);
                            }

                        });
                    } else {
                        Log.i(TAG, "enough coins");
                        sampleSendProps(vcBundle, Utils.random(10000000, 19999999));
                        parent.setEnabled(true);
                    }
                } else {
                    Log.e(TAG, "LCMError: " + error);
                    Utils.showLongToast(getApplicationContext(), "get current balance error.\n" + error.toString());
                    if (samplePbDialog != null) {
                        samplePbDialog.dismiss();
                    }
                    parent.setEnabled(true);
                }
            }
        });
    }
}
