package com.denachina.pickle.ui;

import android.app.Activity;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.Button;
import android.widget.LinearLayout;

import com.denachina.lcm.sdk.LCMSDK;
import com.denachina.pickle.util.ResourceManager;

/**
 * Created by he.b.wang on 16/6/13.
 */
public class MenubarView extends LinearLayout implements View.OnClickListener {
    private Button showMenubarBtn;
    private Button leftTopBtn;
    private Button leftButtomBtn;
    private Button rightTopBtn;
    private Button rightButtomBtn;
    private Button hideMenubarBtn;
    private Activity mActivity;
    private ResourceManager R;

    public MenubarView(Activity activity) {
        super(activity);
        this.mActivity = activity;
        R = ResourceManager.getInstance(mActivity);
        initView();
        setListener();
    }

    private void initView() {
        LayoutInflater inflater = LayoutInflater.from(getContext());
        inflater.inflate(R.getLayoutForId("menubar_list_layout"), this);
        showMenubarBtn = (Button) findViewById(R.getId("show_menubar"));
        leftTopBtn = (Button) findViewById(R.getId("show_menubar_left_top"));
        leftButtomBtn = (Button) findViewById(R.getId("show_menubar_left_buttom"));
        rightTopBtn = (Button) findViewById(R.getId("show_menubar_right_top"));
        rightButtomBtn = (Button) findViewById(R.getId("show_menubar_right_buttom"));
        hideMenubarBtn = (Button) findViewById(R.getId("hide_menubar"));
    }

    private void setListener() {
        showMenubarBtn.setOnClickListener(this);
        leftTopBtn.setOnClickListener(this);
        leftButtomBtn.setOnClickListener(this);
        rightTopBtn.setOnClickListener(this);
        rightButtomBtn.setOnClickListener(this);
        hideMenubarBtn.setOnClickListener(this);
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.getId("show_menubar")) {
            LCMSDK.showMenubar(mActivity);
        }
        else if (v.getId() == R.getId("show_menubar_left_top")) {
            LCMSDK.showMenubar(mActivity, 0);
        }
        else if (v.getId() == R.getId("show_menubar_left_buttom")) {
            LCMSDK.showMenubar(mActivity, 2);
        }
        else if (v.getId() == R.getId("show_menubar_right_top")) {
            LCMSDK.showMenubar(mActivity, 1);
        }
        else if (v.getId() == R.getId("show_menubar_right_buttom")) {
            LCMSDK.showMenubar(mActivity, 3);
        }
        else if (v.getId() == R.getId("hide_menubar")) {
            LCMSDK.hideMenubar(mActivity);
        }
    }
}
